-- Global handler related to logs

--
-- Starts general logs
--
on StartGenLog ()
  lFilename = the moviePath & "Logs\"
  lFilename = lFilename & "IWP" & GetLogTimeStamp() & ".log"
  QI(#genLog).SetFilename(lFilename)
  GenLog(#debug, "General logs started...")
end

--
-- Creates a general log entry
--
on GenLog (theLevel, theMsg)
  QI(#genLog).Log(theLevel, theMsg)
  
  -- FOR DEBUGGING
  lDebugFlag = QI(#config).GetDebugFlag()
  lRunMode = QI(#status).GetRunMode()
  
  if (lDebugFlag = true and lRunMode = "Author") then
    lMsg = ""
    if (theLevel = #error) then
      lMsg = "[ERROR]" && theMsg
    else if (theLevel = #debug) then
      lMsg = "[DEBUG]" && theMsg
    else if (theLevel = #debugnav) then
      lMsg = "[DEBUGNAV]" && theMsg
    else if (theLevel = #info) then
      lMsg = "[INFO]" && theMsg
    end if
    put lMsg
  end if
end

--
-- Stops general logs
--
on StopGenLog ()
  GenLog(#debug, "General logs stopped...")
  CleanInterface(#genLog)
end

--
-- Starts activity logs
--
on StartActLog ()
  lFilename = the moviePath & "Logs\"
  lFilename = lFilename & "ACT" & GetLogTimeStamp() & ".log"
  QI(#actLog).SetFilename(lFilename)
  GenLog(#debug, "Activity logs started...")
end

--
-- Creates a activity log entry
--
on ActLog (theType, theSubType, theDetail)
  QI(#actLog).Log(theType, theSubType, theDetail)
end

--
-- Stops activity logs
--
on StopActLog ()
  GenLog(#debug, "Activity logs stopped...")
  CleanInterface(#actLog)
end

--
-- Creates a server log entry
--
on SvrLog (theDetail)
  -- If connected to OPS, send the error
  if (QI(#opsCom).IsConnected()) then
    QI(#opsCom).RaiseError(theDetail)
  end if
  
  -- If we want to see debug info, do so
  if (QI(#config).GetShowDebugInfo() = true) then
    QI(#debugInfo).Show("ERROR:" & RETURN & RETURN & theDetail)
  end if
end
